#ifndef ADM_CONFIG_H
#define ADM_CONFIG_H

#include "../ADM_coreConfig.h"

#define ADM_BUILD_CLI 1
#define ADM_BUILD_GTK 2
#define ADM_BUILD_QT4 3

/* Jog Shuttle */
#define USE_JOG

#define PACKAGE   "avidemux"
#define ADMLOCALE "/usr/share/locale"

#if ADM_BUILD_GTK == ADM_BUILD_GTK || ADM_BUILD_GTK == ADM_BUILD_QT4
/* use ALSA as possible audio device */
/* #undef ALSA_SUPPORT */
#endif

#if ADM_BUILD_GTK == ADM_BUILD_CLI || ADM_BUILD_GTK == ADM_BUILD_GTK
/* Define if the GNU gettext() function is already present or preinstalled. */
#define HAVE_GETTEXT
#endif

// GTK+ uses X11 framework
#define HAVE_GTK_X11

/* OSS detected */
/* #undef OSS_SUPPORT */

/* use Aften AC3 encoder */
/* #undef USE_AFTEN */
/* #undef USE_AFTEN_07 */
/* #undef USE_AFTEN_08 */
/* #undef USE_AFTEN_08_SVN */

#if ADM_BUILD_GTK == ADM_BUILD_GTK || ADM_BUILD_GTK == ADM_BUILD_QT4
/* aRts detected */
/* #undef USE_ARTS */
#endif

#if ADM_BUILD_GTK == ADM_BUILD_GTK || ADM_BUILD_GTK == ADM_BUILD_QT4
/* ESD detected */
/* #undef USE_ESD */
#endif

/* Jack detected */
/* #undef USE_JACK */

/* FFmpeg */
#define USE_FFMPEG

/* Libxml2 is available */
#define USE_LIBXML2

#if ADM_BUILD_GTK == ADM_BUILD_QT4
/* OpenGL detected */
#define USE_OPENGL
#endif

#if ADM_BUILD_GTK == ADM_BUILD_GTK
/* SDL detected */
#define USE_SDL
#endif

#if ADM_BUILD_GTK == ADM_BUILD_GTK || ADM_BUILD_GTK == ADM_BUILD_QT4
/* XVideo detected */
#define USE_XV
#endif

#define USE_VPX
/* Version number of package */
#define VERSION "2.5.6"

/* use Nvwa memory leak detector */
/* #undef FIND_LEAKS */

#define HAVE_AUDIO

#define HAVE_ENCODER

// FIXME - start
#ifdef HAVE_GETTEXT
#  include <libintl.h>
#  undef _
#endif

extern const char* translate(const char *__domainname, const char *__msgid);

#ifdef QT_TR_NOOP
#undef QT_TR_NOOP
#endif

#define QT_TR_NOOP(String) translate (PACKAGE, String)
// FIXME - end

#endif
